var comp=
{
    props:["value","readonly","shadow"],
    data()
    {
        return{
            canvas:{},
            path:"assets/image/missing.png",
            clicked:true,
            isDraging:false
        }
    },
    async mounted()
    {
        this.canvas = this.$refs.canvas;
        await this.onLoad()      
    },
    watch:
    {
        value:
        {
            deep:true,
            async handler(valN,valO)
            {
                 await this.onLoad()
            }
        }
    },
    methods: 
    {
        refresh()
		{
			this.clicked = false;
			var c = this;
			Vue.nextTick(() =>
			{
				c.clicked = true;
			});
		},
        async onLoad()
        {
            var img = this.value;

            if(img?.id)
            {
                img.data = await FILE.get(img);
            }
            if(img?.data) this.onDraw("data:image/png;base64,"+img.data)
            if(img?.path) this.path = img.path;
            else if(!img?.data) this.onRemove();
        },
        onRemove()
        {
            var canvas = this.canvas;
            this.path = "assets/image/missing.png";
            var ctx = canvas?.getContext("2d");
            if(ctx)
            ctx.clearRect(0, 0, canvas.width, canvas.height);
        },
       
        onChange(event)
        {
            var file = event.target.files[0];
           
            if(file?.type?.match('image.*'))
            {
                console.log("file",file);
                var reader = new FileReader();
                reader.onload = async (event_) => this.onDraw(event_.target.result)
                reader.readAsDataURL(file);	
            }
         
        },
	
        onDraw(val)
        {
            if(val)
            {
                var img_data = ""; 
                var image = new Image();
                image.src = val;
                if(val?.includes?.(","))
                {
                    var split = val.split(',');
                    if(split.length>0) img_data = split[1];
                }
                else   img_data = val;
            
                var image_data= this.value ||{};
                
                image_data.data = img_data;

                this.$emit("input",image_data);
                
                image.onload = () => this.draw(image,"cover");
            }
            this.path = val||"assets/image/missing.png";

        },
        draw (img, type) 
        {
            
            var ctx = this.canvas?.getContext("2d");
            if(!ctx)return
            this.onRemove()
            const imgRatio = img.height / img.width
            const winRatio = ctx.canvas.height /  ctx.canvas.width

            if ((imgRatio <= winRatio && type === 'contain') || (imgRatio >= winRatio && type === 'cover')) 
            {
              const h = ctx.canvas.width * imgRatio
              ctx.drawImage(img, 0, (ctx.canvas.height - h) / 2, ctx.canvas.width, h)
            }
            if ((imgRatio > winRatio && type === 'contain') || (imgRatio < winRatio && type === 'cover')) 
            {
              const w = ctx.canvas.width * winRatio / imgRatio
              ctx.drawImage(img, (ctx.canvas.width - w) / 2, 0, w, ctx.canvas.height)
            }
        },
        onDrop(event)
        {
            var dt = event.dataTransfer
            var files = dt.files
            this.isDraging = false;
            if(!UTIL.Empty(files)) 
            {
                var file = files[0];
                if(file?.type?.match('image.*'))
                {
                    var reader = new FileReader();
                    reader.onload = async (event_) => this.onDraw(event_.target.result,true)
                    reader.readAsDataURL(file);	
                }
                else
                {
                    console.log(file?.type);
                }
            }
        },
        onDragOver(e)
        {
            this.isDraging = true;
        },
        onDragExit(e)
        {
            this.isDraging = false;
        },
        // onPaste(event)
        // {
        //     var cb_data = event.clipboardData;
        //     if (cb_data) 
        //     {
        //         var items = cb_data.items;
        //         if (!items) return;
                
        //         var is_image = false;
        //         for (var i = 0; i < items.length; i++) 
        //         {
        //             if (items[i].type.indexOf("image") !== -1) 
        //             {
        //                 var blob = items[i].getAsFile();
        //                 var URLObj = window.URL || window.webkitURL;
        //                 var source = URLObj.createObjectURL(blob);
        //                 this.onDraw(source,true);
        //                 is_image = true;
        //             }
        //         }
        //         if(is_image == true)
        //         {
        //             event.preventDefault();
        //         }
        //     }
        // },
    },
}