var comp = 
{
	// mixins:[{methods:UTIL}],
	props:
	{
		popups:[Object,Array],
	},
	watch:
	{		
		popups:
		{
			deep:true,
			handler(val)
			{
				this.open_key = (val?.length||1)-1;
			}
		}
	},
	mounted() 
	{
        this.$root.popup = this;

		window.addEventListener('mouseup',e=> this.stopDrag(e));

	},
	data()
	{
		return{
			open_key:-1,
			dragging: false,
			min:{},
			max:{},
			x1:0,
			y1:0,
			x2:0,
			y2:0,
		}
	},
	methods:
	{
		onClose()
		{
			this.$emit("onClose");
			this.$root.popup.close();
		},
		onCancel(popup)
		{
			return UTIL.isFunc(popup.onCancel)?popup.onCancel():()=>console.log("No Cancel");
		},
		startDrag(e) 
		{
			if (!this.dragging) 
			{
				var el = this.$refs['window_'+this.open_key][0];
				if(el)
				{
					this.dragging = true;
					this.x2 = e.clientX;
					this.y2 = e.clientY;
					this.min.x = this.x2-el.offsetLeft+(el.offsetWidth/2);
					this.min.y = this.y2-el.offsetTop+(el.offsetHeight/2);
					this.max.x = el.offsetWidth-this.min.x;
					this.max.y = el.offsetHeight-this.min.y;
					window.addEventListener('mousemove',e=> this.doDrag(e));
				}

			}
		},
		stopDrag() 
		{
			this.dragging = false;
			window.removeEventListener('mousemove',this.doDrag);
		},
		doDrag(e) 
		{
			if (this.dragging) 
			{
				var mX = UTIL.clamp(e.clientX,this.min.x,window.innerWidth-this.max.x);
				var mY = UTIL.clamp(e.clientY,this.min.y,window.innerHeight-this.max.y);
				
				this.x1 = this.x2-mX;
				this.y1 = this.y2-mY;
				this.x2 = mX;
				this.y2 = mY;

				var el = this.$refs['window_'+this.open_key][0];
				el.style.left = (el.offsetLeft - this.x1) + "px";
				el.style.top = (el.offsetTop - this.y1) + "px";
			}
		},
		show(heading,sub,onCancel)
        {
            var popup = {};
            popup.heading = heading||"NO HEADING?";
            popup.sub = sub;
			popup.onCancel = onCancel;
            this.popups.push(popup);
        },
        close(stack)
        {
            var popups = this.popups;
            if(!UTIL.Empty(popups))
            {
                var popup = popups.pop();
            
                if(UTIL.isFunc(popup?.sub?.callback)) popup?.sub?.callback?.(); 
                if(stack||false)popups.length = 0;
            }
        },   
		confirm(heading,message,yes,no)
        {
            heading = heading||"HEADING"
            var sub = {};
            sub.comp = "w-confirm";
            sub.props = {message:message};
            sub.events= {}
    
			
            if(UTIL.isFunc(yes))sub.events.onYes = ()=> 
			{
				yes();
				// this.close(true);
			}
            if(UTIL.isFunc(no))sub.events.onNo =  ()=> 
			{
				no();
				// this.close(true);
			}
			
            this.show(heading,sub);
        },
        prompt(heading,message,ok)
        {
            heading = heading||"HEADING"
            var sub = {};
            sub.comp = "w-prompt";
            sub.props = {message:message};
            sub.events= {}
            
            if(UTIL.isFunc(ok))sub.events.onOk =()=>
            {
                console.log("on OK");
                ok();
            }
            this.show(heading,sub);
        }
  	}
};